// @(#) ENIB/LI2 (c) - C++ Utilities
//--------------------------------------------------------------------------//
// file        : ipcMutex.h                                                 //
// description : header file for the ENIB/LI2 class IPCMutex                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef IPCMUTEX_H
#define IPCMUTEX_H

#include "Utility/smplVect.h"

#ifndef __MSDOS__
// #include <stl_config.h>
#endif

//--------------------------------------------------------------------------//
// class IPCMutex                                                           //
//--------------------------------------------------------------------------//

class IPCMutex : public BlockAllocatedObject
{
public:
// Static Methods
  static void relaxIPCs(void);
// Allocators
  IPCMutex(void);
  IPCMutex(int id);
  virtual ~IPCMutex(void);
// Inspectors
  bool fail(void) const;
  int getID(void) const;
  bool isLocked(void) const;
// Modifiers
  void lock(void);
  bool tryLock(void);
  void unlock(void);
protected:
  friend class SimpleThreadMutex;
  IPCMutex(BlockAllocator * dummy);
// Attributes
  int _id;
  bool _creator;
  static SimpleVector<IPCMutex *> _mtxs;
  static IPCMutex * _allocMutex;
};

#endif // IPCMUTEX_H

