// @(#) ENIB/LI2 (c) - C++ Utilities
//--------------------------------------------------------------------------//
// file        : ipcShMem.h                                                 //
// description : header file for the ENIB/LI2 class IPCSharedMemory         //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef IPCMEM_H
#define IPCMEM_H

#ifndef __MSDOS__
// #include <stl_config.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#endif

#include "Utility/smplVect.h"

//--------------------------------------------------------------------------//
// class IPCSharedMemory                                                    //
//--------------------------------------------------------------------------//

class IPCSharedMemory : public BlockAllocatedObject
{
public:
// Static Methods
  static void relaxIPCs(void);
// Allocators
  IPCSharedMemory(size_t size);
  IPCSharedMemory(int id);
  virtual ~IPCSharedMemory(void);
// Inspectors
  bool fail(void) const;
  int getID(void) const;
  size_t getSize(void) const;
  void * getAddress(void) const;
// Modifiers
protected:
// Attributes
  int _id;
  bool _creator;
  size_t _size;
  void * _address;
#ifndef __MSDOS__
  struct shmid_ds _shmid_ds;
#endif
  static SimpleVector<IPCSharedMemory *> _mems;
};

#endif // IPCMEM_H

