// @(#) ENIB/LI2 (c) - C++ Utilities
//--------------------------------------------------------------------------//
// file        : system.h                                                   //
// description : header file for the ENIB/LI2 class System                  //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef SYSTEM_H
#define SYSTEM_H

#include "Utility/strings.h"

//--------------------------------------------------------------------------//
// class System                                                             //
//--------------------------------------------------------------------------//

class System
{
protected:
  System(void);          // System is an abstract class
  virtual ~System(void);
  static bool (* _userHandler)(int);
  static void _exitHandler(int signum);
public:
// Exit Handler
  static void installExitHandler(bool (*handler)(int));
  static void ignoreTimers(void);
// Dynamic Libraries
  static void * openDynLib(const Strings & libName);
  static void * getDynLibSymbol(void * handle,const Strings & symbName);
  static int closeDynLib(void * handle);
// Command Launching
  static int launch(const Strings & command);
  static void launchI(const Strings & command,
                      const Strings & input);
  static Strings launchO(const Strings & command);
  static Strings launchE(const Strings & command);
  static Strings launchIO(const Strings & command,
                          const Strings & input);
  static Strings launchIE(const Strings & command,
                          const Strings & input);
  static Strings launchOE(const Strings & command,
                          Strings & err);
  static Strings launchIOE(const Strings & command,
                           const Strings & input,
                           Strings & err);
};

#endif // SYSTEM_H

