// @(#) ENIB/LI2 (c) - C++ Utilities
//--------------------------------------------------------------------------//
// file        : word.h                                                     //
// description : header file for the ENIB/LI2 class Word                    //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef WORD_H
#define WORD_H

#include "Utility/strings.h"
#include "Utility/stlMap.h"

//--------------------------------------------------------------------------//
// class Word                                                               //
//--------------------------------------------------------------------------//

class Word : public BlockAllocatedObject
{
public:
// Static Methods
  inline static bool isKnown(const Strings & str);
// Allocators
protected:
  inline Word(const Strings & str); // TO BE CHANGED
public:
  inline static Word create(const Strings & str); // TO BE CHANGED
  inline Word(const Word & word);
  inline virtual ~Word(void);
// Inspectors
  inline const Strings & getStrings(void) const;
// Comparisons
  inline bool operator==(const Word & w) const;
  inline bool operator!=(const Word & w) const;
  inline bool operator<(const Word & w) const;  // not lexicographic !
// Input/output
  friend ostream & operator<<(ostream & stream,const Word & w);
// Modifiers
  inline Word & operator=(const Word & w);
protected:
  class WordData : public BlockAllocatedObject
    {
    public:
      Strings * str;
      int nbRefs;
    };
  WordData * _data;
  typedef StlMap<Strings *,WordData *,StlPtrLess<Strings> > DataMap;
  static DataMap * _dataMap;
};

#include "Utility/word.Ci"

#endif // WORD_H

