// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgArea.h                                                   //
// description : header file for the ENIB/LI2 class XGuiArea                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGAREA_H
#define XGAREA_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiArea                                                           //
//--------------------------------------------------------------------------//

class XGuiTabGroup;

class XGuiArea : public XGuiElement
{
public:
// Allocators
  XGuiArea(XGuiArea * parent=(XGuiArea *)0);
  virtual ~XGuiArea(void);
// Inspectors
  unsigned long getWindowID(void) const;
  virtual int getInWidth(void) const;
  virtual int getInHeight(void) const;
// Modifiers
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void setInWidth(int inWidth);
  virtual void setInHeight(int inHeight);
  virtual void show(void);
//---- Specific ----
// Allocators
protected:
  friend class XGuiTab;
  XGuiArea(XGuiTabGroup * parent);
public:
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
  virtual Window getInWindow(void) const;
// Modifiers
  virtual bool dispatchEvent(const XEvent & event);
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
  void adjustMenu(int width,int height);
};

#endif // XGAREA_H

