// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgBtnDlg.h                                                 //
// description : header file for the ENIB/LI2 class XGuiButtonDialog        //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGBTNDLG_H
#define XGBTNDLG_H

#include "XGui/xgWin.h"

//--------------------------------------------------------------------------//
// class XGuiButtonDialog                                                   //
//--------------------------------------------------------------------------//

class XGuiButtonDialog : public XGuiWindow
{
public:
// Allocators
  XGuiButtonDialog(const Strings & title,const StringsVect & message,
                   const StringsVect & buttons);
  virtual ~XGuiButtonDialog(void);
// Inspectors
  int getAnswer(void) const;
  int getNbButtons(void) const;
  const Strings & getButton(int pos) const;
// Modifiers
  int ask(void);
//---- Specific ----
// Allocators
// Inspectors
// Modifiers
  virtual void redraw(void);
protected:
  static void _resizeCB(XGuiElement * calling,void * data);
  static void _closeCB(XGuiElement * calling,void * data);
  static void _answerCB(XGuiElement * calling,void * data);
// Attributes
  int _nbMsg;
  int _msgWidth;
  int _answer;
  int _lineY;
};

#endif // XGBTNDLG_H

