// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgCArea.h                                                  //
// description : header file for the ENIB/LI2 class XGuiColorArea           //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGCAREA_H
#define XGCAREA_H

#include "XGui/xgArea.h"

//--------------------------------------------------------------------------//
// class XGuiColorArea                                                      //
//--------------------------------------------------------------------------//

class XGuiColorArea : public XGuiArea
{
public:
// Allocators
  XGuiColorArea(XGuiArea * parent,const Strings & color);
  virtual ~XGuiColorArea(void);
// Inspectors
  const Strings & getColor(void) const;
// Modifiers
  void setColor(const Strings & color);
  virtual void show(void);
//---- Specific ----
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
  unsigned long getPixel(void) const;
protected:
// Attributes
  Strings _color;
  bool _allocated;
  unsigned long _pixel;
};

#endif // XGCAREA_H

