// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgColCh.h                                                  //
// description : header file for the ENIB/LI2 class XGuiColorChooser        //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGCOLCH_H
#define XGCOLCH_H

#include "XGui/xgWin.h"

//--------------------------------------------------------------------------//
// class XGuiColorChooser                                                   //
//--------------------------------------------------------------------------//

class XGuiLabel;
class XGuiFrame;
class XGuiCursor;
class XGuiColorArea;
class XGuiList;
class XGuiButton;

class XGuiColorChooser : public XGuiWindow
{
public:
// Allocators
  XGuiColorChooser(const Strings & title,const Strings & message);
  virtual ~XGuiColorChooser(void);
// Inspectors
  bool isEntered(void) const;
  bool isCanceled(void) const;
  const Strings & getColor(void) const;
// Modifiers
  bool ask(Strings & answer);
  void setInitColor(const Strings & color,bool propagate=true);
  virtual void show(void);
//---- Specific ----
// Allocators
// Inspectors
// Modifiers
protected:
  void _readDataBase(void);
  void _readRGB(int & r,int & g,int & b);
  void _setRGB(int r,int g,int b);
  static void _resizeCB(XGuiElement * calling,void * data);
  static void _closeCB(XGuiElement * calling,void * data);
  static void _cursorCB(XGuiElement * calling,void * data);
  static void _nameCB(XGuiElement * calling,void * data);
  static void _enterCB(XGuiElement * calling,void * data);
  static void _cancelCB(XGuiElement * calling,void * data);
// Attributes
  bool _done;
  bool _cancel;
  XGuiLabel * _message;
  XGuiFrame * _rgbFrame;
  XGuiCursor * _rCursor;
  XGuiCursor * _gCursor;
  XGuiCursor * _bCursor;
  XGuiColorArea * _colArea;
  XGuiFrame * _nameFrame;
  XGuiList * _names;
  XGuiLabel * _text;
  XGuiButton * _okBtn;
  XGuiButton * _cancelBtn;
};

#endif // XGCOLCH_H

