// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgCurve.h                                                  //
// description : header file for the ENIB/LI2 class XGuiCurve               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGCURVE_H
#define XGCURVE_H

#include "Utility/strings.h"

#include <X11/Xlib.h>

//--------------------------------------------------------------------------//
// class XGuiCurve                                                          //
//--------------------------------------------------------------------------//

class XGuiGrapher;

class XGuiCurve : public BlockAllocatedObject
{
public:
// Allocators
// Inspectors
// Modifiers
//---- Specific ----
// Allocators
  XGuiCurve(const Strings & color);
  virtual ~XGuiCurve(void);
// Inspectors
  inline const Strings & getColor(void) const;
  inline int getNbPoints(void) const;
  inline virtual void getBoundingBox(double & xmin,double & ymin,
                                     double & xmax,double & ymax) const;
// Input/Output
  friend ostream & operator<<(ostream & stream,const XGuiCurve & curve);
  virtual Strings print(void) const;
// Modifiers
  virtual void addPoint(double x,double y);
  virtual void accumulatePoint(double x,double y);
  virtual void drawInGrapher(XGuiGrapher * grapher);
// Attributes 
protected:
  Strings _color;
  unsigned long _pixel;
  SimpleVector<double> _x;
  SimpleVector<double> _y;
  bool _accumulate;
  double _xmin,_ymin,_xmax,_ymax;
};

#include "XGui/xgCurve.Ci"

#endif // XGCURVE_H

