// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgFileCh.h                                                 //
// description : header file for the ENIB/LI2 class XGuiFileChooser         //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGFILECH_H
#define XGFILECH_H

#include "XGui/xgWin.h"

//--------------------------------------------------------------------------//
// class XGuiFileChooser                                                    //
//--------------------------------------------------------------------------//

class XGuiFrame;
class XGuiLabel;
class XGuiList;
class XGuiButton;

class XGuiFileChooser : public XGuiWindow
{
public:
// Allocators
  XGuiFileChooser(const Strings & title,const Strings & message);
  virtual ~XGuiFileChooser(void);
// Inspectors
  bool isEntered(void) const;
  bool isCanceled(void) const;
  const Strings & getPath(void) const;
  const Strings & getFileName(void) const;
// Modifiers
  bool ask(Strings & answer);
  void setInitPath(const Strings & path);
//---- Specific ----
// Allocators
// Inspectors
// Modifiers
protected:
  static void _resizeCB(XGuiElement * calling,void * data);
  static void _closeCB(XGuiElement * calling,void * data);
  static void _dirsCB(XGuiElement * calling,void * data);
  static void _filesCB(XGuiElement * calling,void * data);
  static void _enterCB(XGuiElement * calling,void * data);
  static void _updateCB(XGuiElement * calling,void * data);
  static void _cancelCB(XGuiElement * calling,void * data);
// Attributes
  Strings _path;
  bool _done;
  bool _cancel;
  XGuiLabel * _message;
  XGuiFrame * _dirFrame;
  XGuiList * _dirs;
  XGuiFrame * _fileFrame;
  XGuiList * _files;
  XGuiLabel * _text;
  XGuiButton * _okBtn;
  XGuiButton * _updtBtn;
  XGuiButton * _cancelBtn;
};

#endif // XGFILECH_H

