// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgLabel.h                                                  //
// description : header file for the ENIB/LI2 class XGuiLabel               //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGLABEL_H
#define XGLABEL_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiLabel                                                          //
//--------------------------------------------------------------------------//

class XGuiArea;

class XGuiLabel : public XGuiElement
{
public:
// Allocators
  XGuiLabel(XGuiArea * parent,const Strings & title,
            bool editable=false,bool deep=false);
  virtual ~XGuiLabel(void);
// Inspectors
// Modifiers
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void setTitle(const Strings & title);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
// Modifiers
  virtual void usingSelection(Window owner);
  virtual bool dispatchEvent(const XEvent & event);
  virtual void processEvent(const XEvent & event);
  bool goLeft(void);
  bool goRight(void);
  bool goStart(void);
  bool goEnd(void);
  void addChar(char c);
  void addSelection(void);
  void delChar(void);
  void delSelection(void);
  virtual void redraw(void);
protected:
// Attributes
  Window _textWindow;
  bool _deep;
  bool _editable;
  int _textX;
  int _textY;
  int _textWidth;
  int _textHeight;
  bool _selectMouse;
  bool _selectKey;
  int _startSel;
  int _endSel;
  bool _inside;
  int _pos;
  int _offset;
  Pixmap _textPixmap;
  Pixmap _pixmap;
};

#endif // XGLABEL_H

