// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgList.h                                                   //
// description : header file for the ENIB/LI2 class XGuiList                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGLIST_H
#define XGLIST_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiList                                                           //
//--------------------------------------------------------------------------//

class XGuiScroller;
class XGuiArea;

class XGuiList : public XGuiElement
{
public:
// Allocators
  XGuiList(XGuiArea * parent,const StringsVect & entries);
  virtual ~XGuiList(void);
// Inspectors
  int getResult(void) const;
  int getNbEntries(void) const;
  const Strings & getEntry(int pos) const;
  bool isEntered(void) const;
// Modifiers
  void setEntries(const StringsVect & entries);
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
// Modifiers
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  void _buildPixmap(void);
  bool _showResult(void);
  void _keyUp(void);
  void _keyDown(void);
  static void _scrollCB(XGuiElement * calling,void * data);
// Attributes
  StringsVect _entries;
  int _result;
  Time _lastTime;
  bool _isEntered;
  Pixmap _textPixmap;
  int _textX;
  int _textY;
  int _textWidth;
  int _textHeight;
  int _totalHeight;
  int _offset;
  XGuiScroller * _scroll;
  Pixmap _pixmap;
};

#endif // XGLIST_H

