// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgOptMnu.h                                                 //
// description : header file for the ENIB/LI2 class XGuiOptionMenu          //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGOPTMNU_H
#define XGOPTMNU_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiOptionMenu                                                     //
//--------------------------------------------------------------------------//

class XGuiArea;

class XGuiOptionMenu : public XGuiElement
{
public:
// Allocators
  XGuiOptionMenu(XGuiArea * parent,const StringsVect & entries);
  virtual ~XGuiOptionMenu(void);
// Inspectors
  int getResult(void) const;
  int getNbEntries(void) const;
  const Strings & getEntry(int pos) const;
// Modifiers
  void setActiveEntry(int pos,bool propagate=true);
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void setTitle(const Strings & title);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
// Modifiers
  virtual void addElement(XGuiElement * element);
  virtual void removeElement(XGuiElement * element);
  virtual void usingMenu(XGuiMenu * menu);
  virtual bool dispatchEvent(const XEvent & event);
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  static void _itemCB(XGuiElement * calling,void * data);
// Attributes
  StringsVect _entries;
  int _result;
  int _textX;
  int _textY;
  int _textWidth;
  int _textHeight;
  bool _inside;
  XGuiMenu * _menu;
};

#endif // XGOPTMNU_H

