// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgScroll.h                                                 //
// description : header file for the ENIB/LI2 class XGuiScroller            //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGSCROLL_H
#define XGSCROLL_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiScroller                                                       //
//--------------------------------------------------------------------------//

class XGuiArea;

class XGuiScroller : public XGuiElement
{
public:
// Allocators
  XGuiScroller(XGuiArea * parent,bool horizontal);
  virtual ~XGuiScroller(void);
// Inspectors
  double getValue(void) const;
  double getRatio(void) const;
// Modifiers
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  void setValue(double value,bool propagate=true);
  void setRatio(double ratio,bool propagate=true);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
  bool isHorizontal(void) const;
// Modifiers
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  friend class XGuiList;
  friend class XGuiEditor;
  XGuiScroller(XGuiElement * parent, // used by XGuiList and XGuiEditor
               bool horizontal);
// Attributes
  bool _horizontal;
  double _value;
  double _ratio;
  int _cursorX;
  int _cursorY;
  int _cursorWidth;
  int _cursorHeight;
  unsigned int _pressed;
  int _offset;
  bool _inside;
  Pixmap _pixmap;
};

#endif // XGSCROLL_H

