// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgTabGrp.h                                                 //
// description : header file for the ENIB/LI2 class XGuiTabGroup            //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGTABGRP_H
#define XGTABGRP_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiTabGroup                                                       //
//--------------------------------------------------------------------------//

class XGuiArea;

class XGuiTabGroup : public XGuiElement
{
public:
// Allocators
  XGuiTabGroup(XGuiArea * parent);
  virtual ~XGuiTabGroup(void);
// Inspectors
  int getCurrentTab(void) const;
  int getNbTabs(void) const;
  const Strings & getTab(int pos) const;
// Modifiers
  void setCurrentTab(int pos,bool propagate=true);
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
// Modifiers
  virtual void addElement(XGuiElement * element);
  virtual void removeElement(XGuiElement * element);
  virtual bool dispatchEvent(const XEvent & event);
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  friend class XGuiTab;
  void _buildHeader(void);
  void _destroyHeader();
// Attributes
  int _xOffset;
  int _yOffset;
  typedef struct
    {
    int width;
    Window window;
    } TabInfo;
  SimpleVector<TabInfo *> _tabs;
  int _current;
  int _inside;
};

#endif // XGTABGRP_H

