// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgToggle.h                                                 //
// description : header file for the ENIB/LI2 class XGuiToggle              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGTOGGLE_H
#define XGTOGGLE_H

#include "XGui/xgElem.h"

//--------------------------------------------------------------------------//
// class XGuiToggle                                                         //
//--------------------------------------------------------------------------//

class XGuiArea;

class XGuiToggle : public XGuiElement
{
public:
// Allocators
  XGuiToggle(XGuiArea * parent,const Strings & title,bool big=false);
  virtual ~XGuiToggle(void);
// Inspectors
  bool isPressed(void) const;
// Modifiers
  void setPressed(bool isPressed,bool propagate=true);
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void setTitle(const Strings & title);
  virtual void show(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
// Modifiers
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  friend class XGuiToggleGroup;
  XGuiToggle(XGuiElement * parent, // used by XGuiToggleGroup
             const Strings & title,bool big=false);
// Attributes
  int _textX;
  int _textY;
  int _textWidth;
  int _textHeight;
  bool _pressed;
  bool _inside;
  bool _big;
};

#endif // XGTOGGLE_H

