// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgTxtDlg.h                                                 //
// description : header file for the ENIB/LI2 class XGuiTextDialog          //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGTXTDLG_H
#define XGTXTDLG_H

#include "XGui/xgWin.h"

//--------------------------------------------------------------------------//
// class XGuiTextDialog                                                     //
//--------------------------------------------------------------------------//

class XGuiLabel;
class XGuiButton;

class XGuiTextDialog : public XGuiWindow
{
public:
// Allocators
  XGuiTextDialog(const Strings & title,const StringsVect & message);
  virtual ~XGuiTextDialog(void);
// Inspectors
  bool isEntered(void) const;
  bool isCanceled(void) const;
  const Strings & getText(void) const;
// Modifiers
  bool ask(Strings & answer);
  void setInitText(const Strings & text);
//---- Specific ----
// Allocators
// Inspectors
// Modifiers
  virtual void redraw(void);
protected:
  static void _resizeCB(XGuiElement * calling,void * data);
  static void _closeCB(XGuiElement * calling,void * data);
  static void _enterCB(XGuiElement * calling,void * data);
  static void _cancelCB(XGuiElement * calling,void * data);
// Attributes
  bool _done;
  bool _cancel;
  int _nbMsg;
  int _msgWidth;
  XGuiLabel * _text;
  XGuiButton * _cancelBtn;
  int _lineY;
};

#endif // XGTXTDLG_H

