// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgWin.h                                                    //
// description : header file for the ENIB/LI2 class XGuiWindow              //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifndef XGWIN_H
#define XGWIN_H

#include "XGui/xgArea.h"

//--------------------------------------------------------------------------//
// class XGuiWindow                                                         //
//--------------------------------------------------------------------------//

class XGuiWindow : public XGuiArea
{
public:
// Allocators
  XGuiWindow(const Strings & title);
  virtual ~XGuiWindow(void);
// Inspectors
  virtual int getInWidth(void) const;
  virtual int getInHeight(void) const;
// Modifiers
  virtual void setX(int x);
  virtual void setY(int y);
  virtual void setWidth(int width);
  virtual void setHeight(int height);
  virtual void setTitle(const Strings & title);
  virtual void setInWidth(int inWidth);
  virtual void setInHeight(int inHeight);
  void setCloseCallback(void (*callback)(XGuiElement *,void *),
                        void * data=(void *)0);
  virtual void show(void);
  virtual void hide(void);
//---- Specific ----
// Allocators
// Inspectors
  virtual XGuiElement::Type getElemType(void) const;
  virtual bool isA(XGuiElement::Type type) const;
  virtual Window getInWindow(void) const;
// Modifiers
  virtual void setMinSize(int minWidth,int minHeight);
  virtual void processEvent(const XEvent & event);
  virtual void redraw(void);
protected:
  void _computeDelta(void);
// Attributes
  Window _inWindow;
  bool _inWidthGiven;
  bool _inHeightGiven;
  void (*_closeCallback)(XGuiElement *,void *);
  void * _closeData;
  static bool _deltaComputed;
  static int _dx,_dy,_dw,_dh;
};

#endif // XGWIN_H

