// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xgCArea.cpp                                                //
// description : source file for the ENIB/LI2 class XGuiColorArea           //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifdef X_GUI

#include "XGui/xgCArea.h"
#include "XGui/xgMgr.h"

//--------------------------------------------------------------------------//
// class XGuiColorArea                                                      //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
XGuiColorArea::XGuiColorArea(XGuiArea * parent,const Strings & color)
 : XGuiArea(parent),
   _color(), _allocated(false), _pixel(0)
{
setColor(color);
}

XGuiColorArea::~XGuiColorArea(void)
{
if(_allocated)
  getXGuiManager()->freeColor(_pixel);
}

//-------- Inspectors ------------------------------------------------------//
XGuiElement::Type XGuiColorArea::getElemType(void) const // virtual
{
return(XGuiElement::COLOR_AREA);
}

bool XGuiColorArea::isA(XGuiElement::Type type) const // virtual
{
return((type==XGuiElement::COLOR_AREA)||XGuiArea::isA(type));
}

const Strings & XGuiColorArea::getColor(void) const
{
return(_color);
}

unsigned long XGuiColorArea::getPixel(void) const
{
return(_pixel);
}

//-------- Modifiers -------------------------------------------------------//
void XGuiColorArea::setColor(const Strings & color)
{
_color=color;
if(_allocated) getXGuiManager()->freeColor(_pixel);
if(getXGuiManager()->allocNamedColor(color,_pixel))
  {
  _allocated=true;
  }
else
  {
  _allocated=false;
  _pixel=getXGuiManager()->getBackground();
  }
if(_window)
  {
  XSetWindowBackground(getXGuiManager()->getDisplay(),_window,_pixel);
  XClearWindow(getXGuiManager()->getDisplay(),_window);
  }
}

void XGuiColorArea::show(void) // virtual
{
if(!_window&&_parent)
  {
  _window=getXGuiManager()->getNewWindow(((XGuiArea *)_parent)->getInWindow(),
                                         _x,_y,_width,_height);
  XSetWindowBackground(getXGuiManager()->getDisplay(),
                       _window,_pixel);
  XMapWindow(getXGuiManager()->getDisplay(),_window);
  }
XGuiElement::show();
}

#endif // X_GUI

