// @(#) ENIB/LI2 (c) - oRis - Version 2.3
//--------------------------------------------------------------------------//
// file        : xsText.cpp                                                 //
// description : source file for the ENIB/LI2 class XGuiText                //
// author(s)   : F. Harrouet                                                //
// copyright   : Laboratoire d'Informatique Industrielle (LI2)              //
//               Ecole Nationale d'Ingenieurs de Brest (ENIB)               //
//               CP 30815 - 29608 Brest Cedex - FRANCE                      //
//               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        //
//               e-mail: li2@enib.fr                                        //
//--------------------------------------------------------------------------//
// Copyright (c) 1996-2000                                                  //
// Laboratoire d'Informatique Industrielle (LI2)                            //
// Ecole Nationale d'Ingenieurs de Brest (ENIB)                             //
//                                                                          //
// Permission to use, copy, modify, distribute and sell this software       //
// and its documentation for any purpose is hereby granted without fee,     //
// provided that the above copyright notice appear in all copies and        //
// that both that copyright notice and this permission notice appear        //
// in supporting documentation.                                             //
// ENIB/LI2 makes no representations about the suitability of this          //
// software for any purpose.                                                //
// It is provided "as is" without express or implied warranty.              //
//--------------------------------------------------------------------------//

#ifdef X_GUI

#include "XGui/xsText.h"
#include "XGui/xgView2d.h"
#include "XGui/xgMgr.h"

//--------------------------------------------------------------------------//
// class XGuiText                                                           //
//--------------------------------------------------------------------------//

//-------- Allocators ------------------------------------------------------//
XGuiText::XGuiText(double x,double y,double theta,const Strings & color,
                   const Strings & text)
 : XGuiShape2D(x,y,theta,color),
   _text(text), _textWidth(getXGuiManager()->getTextWidth(text))
{
computePosition();
}

XGuiText::XGuiText(const XGuiText & s)
 : XGuiShape2D(s),
   _text(s._text), _textWidth(s._textWidth)
{}

XGuiText::~XGuiText(void)
{}

XGuiShape2D * XGuiText::duplicate(void) const // virtual
{
return(new XGuiText(*this));
}

//-------- Inspectors ------------------------------------------------------//
// inline bool XGuiText::isScalable(void) const // virtual

// inline const Strings & XGuiText::getText(void) const

// inline void XGuiText::getLocalBoundingBox(double & xmin,double & ymin,
//                                           double & xmax,double & ymax)
//                                           const // virtual

// inline void XGuiText::getBoundingBox(double & xmin,double & ymin,
//                                      double & xmax,double & ymax,
//                                      const XGuiViewer2D * viewer)
//                                                            const // virtual

// inline double XGuiText::distanceTo(double x,double y,
//                                    const XGuiViewer2D * viewer)
//                                                            const // virtual

bool XGuiText::isInside(double,double) const // virtual
{
return(false);
}

bool XGuiText::intersectRay(double,double,double,double,
                            double &,double &) const // virtual
{
return(false);
}

//-------- Input/Output ----------------------------------------------------//
Strings XGuiText::print(void) const // virtual
{
return("text("+_text.dump()+")");
}

//-------- Modifiers -------------------------------------------------------//
void XGuiText::setText(const Strings & text)
{
_text=text;
_textWidth=getXGuiManager()->getTextWidth(text);
XGuiViewer2D::forceRedraw();
}

void XGuiText::drawInViewer(XGuiViewer2D * viewer) // virtual
{
getXGuiManager()->chooseColor(_pixel);
XDrawString(getXGuiManager()->getDisplay(),
            viewer->getPixmap(),getXGuiManager()->getGC(),
            viewer->getColumn(_x0),
            viewer->getLine(_y0)+getXGuiManager()->getFont()->ascent,
            _text,_text.len());
}

// inline void XGuiText::computePosition(void) // virtual

#endif // X_GUI

